//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ジェライム大ダメージ状態実装
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Enemy/Gelaim/GelaimBigDamageState.h"
#include "Game/Sound/SoundSystem.h"
#include "Enemy/System/Enemy.h"

#include "Enemy/Gelaim/GelaimDeathState.h"
#include "Enemy/Gelaim/GelaimStandState.h"

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
GelaimBigDamageState::GelaimBigDamageState(Gelaim* gelaim) :
	GelaimState(gelaim){
}
//------------------------------------------------------------------------------
// デストラクタ
GelaimBigDamageState::~GelaimBigDamageState(){
}
//------------------------------------------------------------------------------
// 実行
//------------------------------------------------------------------------------
// 初期化
void GelaimBigDamageState::initialize(){
	// 向きの設定
	Vector3 direction = -getDamageDirection();
	direction.y = 0.f;
	setDirection(direction);
	clearDamage();
	// アニメーションシーケンス設定
	getAnimation()->setSequence(5);
	// 速度の初期化
	setVelocity(Vector3(0.f, 1.5f, 0.f));
	// 無敵カウンタ設定
	setMatchlessCounter(10);
	// 音を鳴らす
	getSoundSystem()->play("GelaimBigDamage");
}
//------------------------------------------------------------------------------
// 後始末
void GelaimBigDamageState::finalize(){
}
//------------------------------------------------------------------------------
// 実行
void GelaimBigDamageState::run(){
	// 定数
	float animationScale = 1.f;

	// ステート変更
	if(getRunCounter() == 60){
		if(isDeath()){
			// 死亡
			getEnemy()->setState(new GelaimDeathState(getGelaim()));
		}else{
			// 死んでいなければ立ち
			getEnemy()->setState(new GelaimStandState(getGelaim()));
		}
	}

	// 位置と速度の計算
	float rate = (1.f - ((float)getRunCounter() / 120.f)) * 0.4f;
	calcVelocityAndPosition(-getDirection() * rate);

	// 地形コリジョン
	landCollide();

	// 描画セットアップ
	drawSetup(animationScale);

}
//------------------------------------------------------------------------------
